import { AWSError } from 'aws-sdk';
import { Service } from 'aws-sdk/lib/service';
import Piscina from 'piscina';
import { ClientApiOptions, Constructor, InferredResult, ServiceOperation, ServiceProperties } from './workers/aws-sdk';
declare type PoolOptions = ConstructorParameters<typeof Piscina>[0];
declare class WorkerPool extends Piscina {
    #private;
    constructor(poolOptions?: PoolOptions);
    get done(): boolean;
    get drained(): boolean;
    end(): void;
    begin(): void;
    restart(): void;
    get isFinished(): boolean;
    shutdown(doDestroy?: boolean): Promise<boolean>;
}
export declare class WorkerPoolAwsSdk extends WorkerPool {
    constructor(poolOptions?: PoolOptions);
    runAwsTask<S extends Service = Service, C extends Constructor<S> = Constructor<S>, O extends ServiceProperties<S, C> = ServiceProperties<S, C>, E extends Error = AWSError, N extends ServiceOperation<S, C, O, E> = ServiceOperation<S, C, O, E>>(params?: ClientApiOptions<S, C, O, E, N>): Promise<InferredResult<S, C, O, E, N>>;
}
export {};
