"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Aws = __importStar(require("aws-sdk/clients/all"));
const serialize_error_1 = require("serialize-error");
function getClient(name, options) {
    const clients = Aws;
    let clientName;
    try {
        clientName = Object.keys(clients).find((service) => {
            return name === service || name === clients[service].serviceIdentifier;
        });
        if (clientName) {
            const ClientConstructor = clients[clientName];
            return new ClientConstructor(options);
        }
    }
    catch (err) {
        err.message = `Unable to find AWS service: ${name} or ${clientName}\n${err.message}`;
        throw Error(err);
    }
    throw Error(`Unable to find AWS service: ${name} or ${clientName}`);
}
async function clientApi(params) {
    var _a;
    try {
        const nodeEnv = ((_a = process.env) === null || _a === void 0 ? void 0 : _a.NODE_ENV) || 'production';
        if (nodeEnv !== 'production') {
            console.debug('Client API called with parameters:', params);
        }
        const { name, options, operation, input, headers } = params;
        const client = getClient(name, options);
        const request = client.makeRequest(operation, input);
        const headerEntries = Object.entries(headers || {});
        if (headerEntries.length) {
            request.on('build', () => {
                for (const [key, value] of headerEntries) {
                    request.httpRequest.headers[key] = value;
                }
            });
        }
        return await request.promise();
    }
    catch (err) {
        console.debug(err);
        throw serialize_error_1.serializeError(err);
    }
}
exports.default = clientApi;
